import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;

import static org.junit.Assert.*;

public class ArrazTest {
    Arraz arraz = new Arraz();

    @Before
    public void setUp(){

    }

    @Test
    public void test1sumValuesOfArray(){
        //GIVEN
        int[] arr = {1, 2, 3, 4, 5};

        //WHEN
        int expected = 15;
        int actual = arraz.sumValuesOfArray(arr);

        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test2sumValuesOfArray(){
        //GIVEN
        int[] arr = {1, 2, 3, 4, 5, 100};

        //WHEN
        int expected = 115;
        int actual = arraz.sumValuesOfArray(arr);

        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test1sumDoublesOfArray(){
        //GIVEN
        double[] arr = {1, 2, 3, 4, 5.5};

        //WHEN
        double expected = 15.5;
        double actual = arraz.sumDoublesOfArray(arr);

        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test2sumDoublesOfArray(){
        //GIVEN
        double[] arr = {1.999, 2, 3, 4, 5, 100};

        //WHEN
        double expected = 115.999;
        double actual = arraz.sumDoublesOfArray(arr);

        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test1averageOfArray(){
        //GIVEN
        int[] arr = {1, 2, 3, 4, 5};

        //WHEN
        int expected = 3;
        int actual = arraz.averageOfArray(arr);

        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test2averageOfArray(){
        //GIVEN
        int[] arr = {1, 2, 3, 4, 5, 6};

        //WHEN
        int expected = 3;
        int actual = arraz.averageOfArray(arr);

        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test1doubleAverageOfArray(){
        //GIVEN
        double[] arr = {.75, 2, 3, 4, 5.25};

        //WHEN
        double expected = 3;
        double actual = arraz.doubleAverageOfArray(arr);

        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test2doubleAverageOfArray(){
        //GIVEN
        double[] arr = {.001, 2, 3.141, 4, 5, 6.999};

        //WHEN
        double expected = 3.5235;
        double actual = arraz.doubleAverageOfArray(arr);

        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test1containsValue(){
        //GIVEN
        int[] arr = {1, 2, 3, 4, 5};

        //WHEN
        int test = 3;
        boolean expected = true;
        boolean actual = arraz.containsValue(arr, test);

        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test2containsValue(){
        //GIVEN
        int[] arr = {1, 2, 3, 4, 5, 6};

        //WHEN
        int test = 7;
        boolean expected = false;
        boolean actual = arraz.containsValue(arr, test);

        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test1reverseArray(){
        //GIVEN
        int[] arr = {1, 2, 3, 4, 5};

        //WHEN
        int[] expected = {5, 4, 3, 2, 1};
        int[] actual = arraz.reverseArray(arr);

        //THEN
        Assert.assertEquals(arr[1], actual[3]);
    }

    @Test
    public void test2reverseArray(){
        //GIVEN
        int[] arr = {-2, -1, 0, 1};

        //WHEN
        int[] expected = {1, 0, -1, -2};
        int[] actual = arraz.reverseArray(arr);

        //THEN
        Assert.assertEquals(arr[0], actual[3]);
    }

    @Test
    public void test1getOddEvensOfArray(){
        //GIVEN
        int[] arr = {1, 2, 3, 4, 5};

        //WHEN
        int expected = 2;
        int actual = arraz.getOddEvensOfArray(arr).evens;

        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test2getOddEvensOfArray(){
        //GIVEN
        int[] arr = {1, 2, 3, 4, 5};

        //WHEN
        int expected = 3;
        int actual = arraz.getOddEvensOfArray(arr).odds;

        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test1findIndexOf() {
        //GIVEN
        int[] arr = {1, 2, 3, 4, 5};
        int index = 4;
        //WHEN
        int expected = 5;
        int actual = arraz.findIndexOf(arr, index);

        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test2findIndexOf() {
        //GIVEN
        int[] arr = {1, 2, 3, 4, 5};
        int index = 1;
        //WHEN
        int expected = 2;
        int actual = arraz.findIndexOf(arr, index);

        //THEN
        Assert.assertEquals(expected, actual);
    }

//    @Test
//    public void test1copyArrayByIterator() {
//        //GIVEN
//        Object[] arr = {1, 2, 3, 4, 5};
//        //WHEN
//        Object[] retObject = arraz.copyArrayByIterator(arr);
//        int expected = 3;
//
//        //THEN
//        int actual = retObject.;
//        Assert.assertEquals(expected, actual);
//    }
//
//    @Test
//    public void test2copyArrayByIterator() {
//
//    }

    @Test
    public void test1copyArrayByLoop() {
        //GIVEN
        int[] expected = {1, 2, 3, 4, 5};
        //WHEN
        int[] actual = arraz.copyArrayByLoop(expected);

        //THEN
        Assert.assertEquals(expected[0], actual[0]);
    }

    @Test
    public void test2copyArrayByLoop() {
        //GIVEN
        int[] expected = {1, 2, 3, 4, 5};
        //WHEN
        int[] actual = arraz.copyArrayByLoop(expected);

        //THEN
        Assert.assertEquals(expected[expected.length - 1], actual[expected.length - 1]);
    }

    @Test
    public void test1removeElementFromArray() {
        //GIVEN
        int[] arr = {1, 2, 3, 4, 5};
        int removeInt = 5;
        //WHEN
        int expected = 4;
        int actual = arraz.removeElementFromArray(arr, removeInt).length;
        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test2removeElementFromArray() {
        //GIVEN
        int[] arr = {1, 2, 3, 4, 5};
        int removeInt = 1;
        //WHEN
        int expected = 2;
        int[] actual = arraz.removeElementFromArray(arr, removeInt);
        //THEN
        Assert.assertEquals(expected, actual[0]);
    }

    @Test
    public void test1insertIntoArrayAt() {
        //GIVEN
        int[] arr = {1, 2, 3, 4, 5};
        int addInt = 6;
        int atIndex = 3;
        //WHEN
        int expected = 6;
        int[] retArr = arraz.insertIntoArrayAt(arr, atIndex, addInt);
        int actual = retArr[atIndex];
        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test2insertIntoArrayAt() {
        //GIVEN
        int[] arr = {1, 2, 3, 4, 5};
        int addInt = 6;
        int atIndex = 5;
        //WHEN
        int expected = 6;
        int[] retArr = arraz.insertIntoArrayAt(arr, atIndex, addInt);
        int actual = retArr[atIndex];
        //THEN
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test1findMaxMinOfArray() {
        //GIVEN
        int[] arr = {1, 2, 3, 4, 5};
        //WHEN
        int expectedMax = 5;
        int expectedMin = 1;
        MaxMin maxMin = arraz.findMaxMinOfArray(arr);

        int actualMax = maxMin.max;
        int actualMin = maxMin.min;
        //THEN
        Assert.assertEquals(expectedMax, actualMax);
        Assert.assertEquals(expectedMin, actualMin);
    }

    @Test
    public void test2findMaxMinOfArray() {
        //GIVEN
        int[] arr = {1, -2, 300, 4, 5};
        //WHEN
        int expectedMax = 300;
        int expectedMin = -2;
        MaxMin maxMin = arraz.findMaxMinOfArray(arr);

        int actualMax = maxMin.max;
        int actualMin = maxMin.min;
        //THEN
        Assert.assertEquals(expectedMax, actualMax);
        Assert.assertEquals(expectedMin, actualMin);
    }

    @Test
    public void test1removeDupesFromArray() {
        //GIVEN
        int[] arr = {1, 2, 3, 4, 5, 3};
        //WHEN
        int expectedLength = 5;

        int actualLength = arraz.removeDupesFromArray(arr).length;
        //THEN
        Assert.assertEquals(expectedLength, actualLength);
    }

    @Test
    public void test2removeDupesFromArray() {
        //GIVEN
        int[] arr = {1, 2, 3, 4, 5, 3, 1, 1, 1, 2, 3, 4, 5};
        //WHEN
        int expectedLength = 5;

        int actualLength = arraz.removeDupesFromArray(arr).length;
        //THEN
        Assert.assertEquals(expectedLength, actualLength);
    }

    @Test
    public void test3removeDupesFromArray() {
        //GIVEN
        int[] arr = {1, 2, 3, 4, 5, 3, 1, 1, 1, 2, 3, 4, 5, 6};
        //WHEN
        int expected = 6;

        int[] actualArray = arraz.removeDupesFromArray(arr);
        int actual = actualArray[5];
        //THEN
        Assert.assertEquals(expected, actual);
    }
}